## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005

from CvPythonExtensions import *
import CvUtil
import CvEventManager
import PyHelpers
import CvAdvisorUtils
import sys
import CustomFunctions
	
# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
cf = CustomFunctions.CustomFunctions()


###################################################
class CvCustomEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

	def onBuildingBuilt(self, argsList):
		'Building Completed'
		pCity, iBuildingType = argsList
		game = CyGame()
		if ((not self.bMultiPlayer) and (pCity.getOwner() == CyGame().getActivePlayer()) and isWorldWonderClass(gc.getBuildingInfo(iBuildingType).getBuildingClassType())):
			# If this is a wonder...
			popupInfo = CyPopupInfo()
			popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
			popupInfo.setData1(iBuildingType)
			popupInfo.setData2(pCity.getID())
			popupInfo.setData3(0)
			popupInfo.setText(u"showWonderMovie")
			popupInfo.addPopup(pCity.getOwner())

                Inquisition = gc.getInfoTypeForString('BUILDING_INQUISITION')
    		if iBuildingType == Inquisition:
                    cf.Inquisit(pCity)
                    pCity.setHasRealBuilding(Inquisition, False)

        def onCityDoTurn(self, argsList):
		'City Production'
		pCity = argsList[0]
		iPlayer = argsList[1]
		
                cf.GiveFoodBonus(pCity)
                cf.GiveProductionBonus(pCity)
                cf.AssignCustomCulture(pCity, iPlayer)

#               Check this city for bonuses 20 to 34 (Dye, Fur, Gems, Hit Movies, ect)
#                for i in range(15):
#                    if pCity.hasBonus(i+20):
#                        CommerceBonus += 0.05
#                CommerceBonus = int(pCity.getCommerceRate(COMMERCE_GOLD) * CommerceBonus)
#
#                pCity.changeGold(CommerceBonus)

#                if (not pCity.isDisorder()):
#                    CultureBonus = int(pCity.getExtraHappiness() * pCity.getBaseCommerceRate(COMMERCE_CULTURE) * 0.05)
#                    if CultureBonus > 0:
#                        pCity.changeCulture(iPlayer, CultureBonus)

		CvAdvisorUtils.cityAdvise(pCity, iPlayer)
		CvUtil.pyPrint("%s has performed its turn." %(pCity.getName(),))

	def onBuildingBuilt(self, argsList):
		'Building Completed'
		pCity, iBuildingType = argsList
		game = CyGame()
		if ((not self.bMultiPlayer) and (pCity.getOwner() == CyGame().getActivePlayer()) and isWorldWonderClass(gc.getBuildingInfo(iBuildingType).getBuildingClassType())):
			# If this is a wonder...
			popupInfo = CyPopupInfo()
			popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
			popupInfo.setData1(iBuildingType)
			popupInfo.setData2(pCity.getID())
			popupInfo.setData3(0)
			popupInfo.setText(u"showWonderMovie")
			popupInfo.addPopup(pCity.getOwner())

#               If the enhancing buildings are built, assign a free specialist and destroy the enhancing building
                if iBuildingType == gc.getInfoTypeForString('BUILDING_HYDROPONICS_FARM'):
                    pCity.changeFreeSpecialistCount(gc.getInfoTypeForString('SPECIALIST_HYDROPONICS_FARM'), 1)
                    pCity.setHasRealBuilding(iBuildingType, False)

		CvAdvisorUtils.buildingBuiltFeats(pCity, iBuildingType)

#		if (not self.__LOG_BUILDING):
#			return
#		CvUtil.pyPrint('%s was finished by Player %d Civilization %s' 
#			%(PyInfo.BuildingInfo(iBuildingType).getDescription(), pCity.getOwner(), gc.getPlayer(pCity.getOwner()).getCivilizationDescription(0)))

	def onImprovementBuilt(self, argsList):
		'Improvement Built'
		iImprovement, iX, iY = argsList

		pPlot = CyMap().plot(iX,iY)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TERRAFORM_GRASS'):
			pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_IMPROVED_GRASS'), true, true)
			pPlot.setImprovementType(-1)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TERRAFORM_PLAINS'):
			pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_IMPROVED_PLAINS'), true, true)
			pPlot.setImprovementType(-1)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TERRAFORM_DESERT'):
			pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_IMPROVED_DESERT'), true, true)
			pPlot.setImprovementType(-1)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TERRAFORM_TUNDRA'):
			pPlot.setTerrainType(gc.getInfoTypeForString('TERRAIN_IMPROVED_TUNDRA'), true, true)
			pPlot.setImprovementType(-1)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TERRAFORM_ICE'):
			pPlot.setTerrainType(CyGlobalContext().getInfoTypeForString('TERRAIN_IMPROVED_ICE'), true, true)
			pPlot.setImprovementType(-1)
		if iImprovement == gc.getInfoTypeForString('IMPROVEMENT_TREE_NURSERY_2'):
			pPlot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST'), 0)
			pPlot.setImprovementType(-1)
